
CoCoALib - Bug #936

ReadExpr: cannot handle exponent which is not integer literal

05 Oct 2016 17:08 - John Abbott

Status: Closed Start date: 05 Oct 2016

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Improving Estimated time: 1.50 hour

Target version: CoCoALib-0.99550 spring 2017 Spent time: 1.35 hour

Description

The fn ReadExpr fails if input contains an exponent which is not an integer literal: for instance

ReadExpr(QQ, "1.2*10^(-3)");

triggers an error saying that the "(" is unexpected.    

At least negative exponents in brackets should be allowed!

Related issues:

Related to CoCoALib - Bug #938: ReadExpr: misreads 2/3^4 Closed 06 Oct 2016

Related to CoCoA-5 - Feature #909: ReadExpr: decimal point Closed 14 Jul 2016

History

#1 - 05 Oct 2016 17:12 - John Abbott

What exactly do we want to allow in the exponents?

The simplest solution would be to allow either an integer literal (possibly with whitespace before it), or an integer literal inside round brackets.  This

would cover the most common cases.

Is there any reason to allow more complicated exponents?  For instance 10^(2+3+4)  I can see no real need for this.

The KISS philosophy suggests that we should aim for the simplest reasonable solution.

#2 - 05 Oct 2016 17:12 - John Abbott

The relevant source is around line 100 of RingElemInput.C

#3 - 06 Oct 2016 07:47 - Anna Maria Bigatti

John Abbott wrote:

What exactly do we want to allow in the exponents?

The simplest solution would be to allow either an integer literal (possibly with whitespace before it), or an integer literal inside round brackets. 

This would cover the most common cases.

 

I agree
#4 - 08 Oct 2016 22:10 - John Abbott

- Status changed from New to Feedback

- Assignee set to John Abbott

- % Done changed from 0 to 90

I have now implemented the following:

after ^ there may be an unsigned integer literal or ( optional-sign unsigned integer literal )

Whitespace is allowed around ^ and ( and ).

Note that a negative exponent must be placed in round brackets; giving ReadExpr the string 1^-1 will produce an error.

#5 - 08 Oct 2016 22:10 - John Abbott

- Related to Bug #938: ReadExpr: misreads 2/3^4 added

#6 - 08 Oct 2016 22:10 - John Abbott

- Related to Feature #909: ReadExpr: decimal point added

#7 - 09 Nov 2016 10:53 - John Abbott

- Target version changed from CoCoALib-0.99560 to CoCoALib-0.99550 spring 2017

#8 - 18 Nov 2016 22:22 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 1.50 h
